from z3 import *
set_param(proof=True)
try:
	CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
	map= DeclareSort('map')
	EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
	address= DeclareSort('address')
	msg_sender= Const('msg_sender',address)
	d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
	bal= Int('bal')
	void= DeclareSort('void')
	_1solidity= Const('_1solidity',void)
	convertToaddress= Function('convertToaddress',address,address)
	LOW_LEVEL_CALL_send= Function('LOW_LEVEL_CALL_send',address,IntSort(),BoolSort())
	sent= Const('sent',BoolSort())
	_2solidity= Const('_2solidity',void)
	_1reentrancy_verifier= Int('_1reentrancy_verifier')
	_2reentrancy_verifier= Int('_2reentrancy_verifier')
	IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
	EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
	msg_sender1= Const('msg_sender1',address)
	d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
	bal1= Int('bal1')
	_1solidity1= Const('_1solidity1',void)
	convertToaddress1= Function('convertToaddress1',address,address)
	LOW_LEVEL_CALL_send1= Function('LOW_LEVEL_CALL_send1',address,IntSort(),BoolSort())
	sent1= Const('sent1',BoolSort())
	_2solidity1= Const('_2solidity1',void)
	_1reentrancy_verifier1= Int('_1reentrancy_verifier1')
	_2reentrancy_verifier1= Int('_2reentrancy_verifier1')
	_y1= Const('_y1',CONRT_EtherStore)
	_y2= Const('_y2',address)
	_y3= Const('_y3',address)
	_y4= Int('_y4')
	_y5= Const('_y5',map)
	_y6= Const('_y6',address)
	_y7= Const('_y7',CONRT_EtherStore)
	_y8= Const('_y8',CONRT_EtherStore)
	_y9= Const('_y9',CONRT_EtherStore)
	_y10= Const('_y10',CONRT_EtherStore)
	_y11= Const('_y11',CONRT_EtherStore)
	_y12= Const('_y12',CONRT_EtherStore)
	_s=Solver()
	_s.set("timeout",50000)
	_s.add(ForAll([_y1],EtherStore_balances1(_y1)==EtherStore_balances(_y1)))
	_s.add(_1solidity1==_1solidity)
	_s.add(ForAll([_y2],convertToaddress1(_y2)==convertToaddress(_y2)))
	_s.add(ForAll([_y3,_y4],LOW_LEVEL_CALL_send1(_y3,_y4)==LOW_LEVEL_CALL_send(_y3,_y4)))
	_s.add(ForAll([_y5,_y6,_y7,msg_sender],d1FaddressTuint256mapping1(_y5,_y6)==If(((d1FaddressTuint256mapping(EtherStore_balances(_y7),msg_sender))>(0)),If(((If(And(((EtherStore_balances(_y7))==(EtherStore_balances(_y7))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y7),msg_sender)))>(0)),If(And(((_y5)==(EtherStore_balances(_y7))),((_y6)==(msg_sender))),0,If(And(((_y5)==(EtherStore_balances(_y7))),((_y6)==(msg_sender))),0,d1FaddressTuint256mapping(_y5,_y6))),If(And(((_y5)==(EtherStore_balances(_y7))),((_y6)==(msg_sender))),0,d1FaddressTuint256mapping(_y5,_y6))),d1FaddressTuint256mapping(_y5,_y6))))
	_s.add(ForAll([_y8,msg_sender],bal1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y8),msg_sender))>(0)),If(And(((EtherStore_balances(_y8))==(EtherStore_balances(_y8))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y8),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y8),msg_sender))))
	_s.add(ForAll([_y9,msg_sender],sent1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y9),msg_sender))>(0)),LOW_LEVEL_CALL_send(convertToaddress(msg_sender),If(And(((EtherStore_balances(_y9))==(EtherStore_balances(_y9))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y9),msg_sender))),sent)))
	_s.add(ForAll([_y10,msg_sender],_1reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y10),msg_sender))>(0)),1,0)))
	_s.add(ForAll([_y11,msg_sender],_2reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y11),msg_sender))>(0)),If(((If(And(((EtherStore_balances(_y11))==(EtherStore_balances(_y11))),((msg_sender)==(msg_sender))),0,d1FaddressTuint256mapping(EtherStore_balances(_y11),msg_sender)))>(0)),1,0),0)))
	_s.add(ForAll([_y12,msg_sender],((d1FaddressTuint256mapping(EtherStore_balances(_y12),msg_sender))>(0))))
	_s.add(Not(And((_1reentrancy_verifier1==1),(_2reentrancy_verifier1==0))))
except Exception as e:
	print("Error1(Z3Query)"+str(e))
	sys.exit(1)
try:
	result=_s.check()
	if sat==result:
		print("Counter Example")
		print (_s.model())
	elif unsat==result:
		print ("Successfully Proved")
	else:
		print("Failed To Prove")
except Exception as e:
	print("Error2(Z3Query)"+str(e))
	sys.exit(1)